

本文属于机器翻译版本。若本译文内容与英语原文存在差异，则一律以英文原文为准。

# 以编程方式下载 IDT
<a name="idt-programmatic-download-process"></a>

IDT 提供了一个 API 操作，您可以使用该操作来检索 URL，也可以在其中以编程方式下载 IDT。您还可以使用此 API 操作来检查是否具有最新版本的 IDT。此 API 操作具有以下端点。

```
https://download.devicetester.iotdevicesecosystem.amazonaws.com/latestidt
```

要调用此 API 操作，您必须具有执行 **iot-device-tester:LatestIdt** 操作的权限。包括您的 Amazon 签名，并以此`iot-device-tester`作为服务名称

## API 请求
<a name="idt-programmatic-download-request"></a>

HostOs — 主机的操作系统。从以下选项中进行选择：  
+ `mac`
+ `linux`
+ `windows`

TestSuiteType — 测试套件的类型。选择以下选项：  
`FR` – 适用于 FreeRTOS 的 IDT

ProductVersion  
（可选）FreeRTOS 的版本。该服务返回适用于此 FreeRTOS 版本的 IDT 的最新兼容版本。如果不指定此选项，则该服务将返回 IDT 的最新版本。

## API 响应
<a name="idt-programmatic-download-response"></a>

API 响应采用以下格式。`DownloadURL` 包括一个 zip 文件。

```
{
    "Success": {{True or False}},
    "Message": {{Message}},
    "LatestBk": {
        "Version": {{The version of the IDT binary}},
        "TestSuiteVersion": {{The version of the test suite}},
        "DownloadURL": {{The URL to download the IDT Bundle, valid for one hour}}
    }
 }
```

## 示例
<a name="idt-programmatic-download-examples"></a>

您可以参考以下示例以编程方式下载 IDT。这些示例使用您在 `AWS_ACCESS_KEY_ID` 和 `AWS_SECRET_ACCESS_KEY` 环境变量中存储的凭证。要遵循最佳安全实践，请勿在代码中存储您的凭证。

**Example**  
**示例：使用 cURL 版本 7.75.0 或更高版本下载（Mac 和 Linux）**  
如果您的 cURL 版本为 7.75.0 或更高版本，则可以使用 `aws-sigv4` 标记对 API 请求进行签名。该示例使用 [jq](https://stedolan.github.io/jq/) 来解析响应中的下载 URL。  
该`aws-sigv4`标志要求 curl GET 请求的查询参数按**HostOs/ProductVersion/TestSuiteType**或 **HostOs/TestSuiteType**的顺序排列。如果参数顺序不符合要求，则会导致从 API Gateway 获得不匹配的规范字符串签名错误。  
如果包含可选参数 **ProductVersion**，则必须使用支持的产品版本，如 for [FreeRTOS Amazon IoT Device Tester 的支持版本](https://docs.amazonaws.cn/freertos/latest/userguide/dev-test-versions-afr.html)中所述。
+ 替换{{us-west-2}}为你的 Amazon Web Services 区域。有关区域代码的列表，请参阅[区域端点](https://docs.amazonaws.cn/general/latest/gr/rande.html#regional-endpoints)。
+ {{linux}}替换为主机的操作系统。
+ {{202107.00}}替换为你的 FreeRTOS 版本。

```
url=$(curl --request GET "https://download.devicetester.iotdevicesecosystem.amazonaws.com/latestidt?HostOs={{linux}}&ProductVersion={{202107.00}}&TestSuiteType=FR" \
--user $AWS_ACCESS_KEY_ID:$AWS_SECRET_ACCESS_KEY \
--aws-sigv4 "aws:amz:{{us-west-2}}:iot-device-tester" \
| jq -r '.LatestBk["DownloadURL"]')

curl $url --output devicetester.zip
```

**Example**  
**示例：使用早期版本的 cURL 下载（Mac 和 Linux）**  
您可以将以下 curl 命令与您签名并计算的 Amazon 签名一起使用。有关如何签名和计算签名的更多信息，请参阅 Amazon [签名 Amazon API 请求](https://docs.amazonaws.cn/IAM/latest/UserGuide/reference_sigv.html)。  
+ {{linux}}替换为主机的操作系统。
+ {{Timestamp}}替换为日期和时间，例如**20220210T004606Z**。
+ {{Date}}替换为日期，例如**20220210**。
+ 替换{{AWSRegion}}为你的 Amazon Web Services 区域。有关区域代码的列表，请参阅[区域端点](https://docs.amazonaws.cn/general/latest/gr/rande.html)。
+ {{AWSSignature}}替换为您生成的[Amazon 签名](https://docs.amazonaws.cn/IAM/latest/UserGuide/reference_sigv-create-signed-request.html)。

```
curl --location --request GET 'https://download.devicetester.iotdevicesecosystem.amazonaws.com/latestidt?HostOs={{linux}}&TestSuiteType=FR' \
--header 'X-Amz-Date: {{Timestamp}} \
--header 'Authorization: AWS4-HMAC-SHA256 Credential=$AWS_ACCESS_KEY_ID/{{Date}}/{{AWSRegion}}/iot-device-tester/aws4_request, SignedHeaders=host;x-amz-date, Signature={{AWSSignature}}'
```

**Example**  
**示例：使用 Python 脚本下载**  
此示例使用 Python [请求](https://pypi.org/project/requests/)库。此示例改编自*Amazon 通用参考*中的 Python 示例，用于[签署 Amazon API 请求](https://docs.amazonaws.cn/IAM/latest/UserGuide/reference_sigv.html)。    
  
+ 请将 {{us-west-2}} 替换为您的区域。有关区域代码的列表，请参阅[区域端点](https://docs.amazonaws.cn/general/latest/gr/rande.html)。
+ {{linux}}替换为主机的操作系统。

```
# Copyright 2010-2022 Amazon.com, Inc. or its affiliates. All Rights Reserved.
#
# This file is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. A copy of the
#License is located at
#
# http://aws.amazon.com/apache2.0/
#
# This file is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS
# OF ANY KIND, either express or implied. See the License for the specific
# language governing permissions and limitations under the License.

# See: http://docs.aws.amazon.com/general/latest/gr/sigv4_signing.html
# This version makes a GET request and passes the signature
# in the Authorization header.
import sys, os, base64, datetime, hashlib, hmac 
import requests # pip install requests
# ************* REQUEST VALUES *************
method = 'GET'
service = 'iot-device-tester'
host = 'download.devicetester.iotdevicesecosystem.amazonaws.com'
region = '{{us-west-2}}'
endpoint = 'https://download.devicetester.iotdevicesecosystem.amazonaws.com/latestidt'
request_parameters = 'HostOs={{linux}}&TestSuiteType=FR'

# Key derivation functions. See:
# http://docs.aws.amazon.com/general/latest/gr/signature-v4-examples.html#signature-v4-examples-python
def sign(key, msg):
    return hmac.new(key, msg.encode('utf-8'), hashlib.sha256).digest()

def getSignatureKey(key, dateStamp, regionName, serviceName):
    kDate = sign(('AWS4' + key).encode('utf-8'), dateStamp)
    kRegion = sign(kDate, regionName)
    kService = sign(kRegion, serviceName)
    kSigning = sign(kService, 'aws4_request')
    return kSigning

# Read AWS access key from env. variables or configuration file. Best practice is NOT
# to embed credentials in code.
access_key = os.environ.get('AWS_ACCESS_KEY_ID')
secret_key = os.environ.get('AWS_SECRET_ACCESS_KEY')
if access_key is None or secret_key is None:
    print('No access key is available.')
    sys.exit()

# Create a date for headers and the credential string
t = datetime.datetime.utcnow()
amzdate = t.strftime('%Y%m%dT%H%M%SZ')
datestamp = t.strftime('%Y%m%d') # Date w/o time, used in credential scope

# ************* TASK 1: CREATE A CANONICAL REQUEST *************
# http://docs.aws.amazon.com/general/latest/gr/sigv4-create-canonical-request.html
# Step 1 is to define the verb (GET, POST, etc.)--already done.
# Step 2: Create canonical URI--the part of the URI from domain to query 
# string (use '/' if no path)
canonical_uri = '/latestidt' 
# Step 3: Create the canonical query string. In this example (a GET request),
# request parameters are in the query string. Query string values must
# be URL-encoded (space=%20). The parameters must be sorted by name.
# For this example, the query string is pre-formatted in the request_parameters variable.
canonical_querystring = request_parameters
# Step 4: Create the canonical headers and signed headers. Header names
# must be trimmed and lowercase, and sorted in code point order from
# low to high. Note that there is a trailing \n.
canonical_headers = 'host:' + host + '\n' + 'x-amz-date:' + amzdate + '\n'
# Step 5: Create the list of signed headers. This lists the headers
# in the canonical_headers list, delimited with ";" and in alpha order.
# Note: The request can include any headers; canonical_headers and
# signed_headers lists those that you want to be included in the 
# hash of the request. "Host" and "x-amz-date" are always required.
signed_headers = 'host;x-amz-date'
# Step 6: Create payload hash (hash of the request body content). For GET
# requests, the payload is an empty string ("").
payload_hash = hashlib.sha256(('').encode('utf-8')).hexdigest()
# Step 7: Combine elements to create canonical request
canonical_request = method + '\n' + canonical_uri + '\n' + canonical_querystring + '\n' + canonical_headers + '\n' + signed_headers + '\n' + payload_hash

# ************* TASK 2: CREATE THE STRING TO SIGN*************
# Match the algorithm to the hashing algorithm you use, either SHA-1 or
# SHA-256 (recommended)
algorithm = 'AWS4-HMAC-SHA256'
credential_scope = datestamp + '/' + region + '/' + service + '/' + 'aws4_request'
string_to_sign = algorithm + '\n' +  amzdate + '\n' +  credential_scope + '\n' +  hashlib.sha256(canonical_request.encode('utf-8')).hexdigest()
# ************* TASK 3: CALCULATE THE SIGNATURE *************
# Create the signing key using the function defined above.
signing_key = getSignatureKey(secret_key, datestamp, region, service)
# Sign the string_to_sign using the signing_key
signature = hmac.new(signing_key, (string_to_sign).encode('utf-8'), hashlib.sha256).hexdigest()

# ************* TASK 4: ADD SIGNING INFORMATION TO THE REQUEST *************
# The signing information can be either in a query string value or in 
# a header named Authorization. This code shows how to use a header.
# Create authorization header and add to request headers
authorization_header = algorithm + ' ' + 'Credential=' + access_key + '/' + credential_scope + ', ' +  'SignedHeaders=' + signed_headers + ', ' + 'Signature=' + signature
# The request can include any headers, but MUST include "host", "x-amz-date", 
# and (for this scenario) "Authorization". "host" and "x-amz-date" must
# be included in the canonical_headers and signed_headers, as noted
# earlier. Order here is not significant.
# Python note: The 'host' header is added automatically by the Python 'requests' library.
headers = {'x-amz-date':amzdate, 'Authorization':authorization_header}

# ************* SEND THE REQUEST *************
request_url = endpoint + '?' + canonical_querystring
print('\nBEGIN REQUEST++++++++++++++++++++++++++++++++++++')
print('Request URL = ' + request_url)
response = requests.get(request_url, headers=headers)
print('\nRESPONSE++++++++++++++++++++++++++++++++++++')
print('Response code: %d\n' % response.status_code)
print(response.text)

download_url = response.json()["LatestBk"]["DownloadURL"]
r = requests.get(download_url)
open('devicetester.zip', 'wb').write(r.content)
```